// FLIXMIX t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

bool fxcut(char *_sname, char *_dname, int _loc, int _size);

struct fpos
{
	char filename[FILENAME_MAX];
	int loc;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	unsigned char buff[0x100];	// t@Cp
	char id1[] = "ZX IWi";
	char id2[] = "i`}Ch";
	FILE *fp;
	int f;

	struct fpos md1[] =
	{
		{ "FLIX02@.MO2",  0x109024, 0x074d },
		{ "FLIX03@.MO2",  0x109771, 0x0f10 },
		{ "FLIX04@.MO2",  0x10a681, 0x10bc },
		{ "FLIX05@.MO2",  0x10b73d, 0x0d61 },
		{ "FLIX06@.MO2",  0x10c49e, 0x1520 },
		{ "FLIX07@.MO2",  0x10d9be, 0x1654 },
		{ "FLIX08@.MO2",  0x10f012, 0x0d76 },
		{ "FLIX09@.MO2",  0x10fd88, 0x15c7 },
		{ "FLIX10@.MO2",  0x11134f, 0x115d },
		{ "FLIX11@.MO2",  0x1124ac, 0x138d },
		{ "FLIX12@.MO2",  0x113839, 0x09e4 },
		{ "FLIX13@.MO2",  0x11421d, 0x05e9 },
		{ "FLIX01@.MO2",  0x114806, 0x070f },
		{ "",             0x000000, 0x0000 },	// End of Data
	};

	struct fpos md2[] =
	{
//		{ "FLIX02@.MO2",  0x1c40eb, 0x074d },
//		{ "FLIX12@.MO2",  0x1cd349, 0x09e4 },
//		{ "FLIX13@.MO2",  0x1cdd2d, 0x05e9 },
//		{ "FLIX01@.MO2",  0x1ce316, 0x070f },
		{ "VAL236@.MO8",  0x1c4838, 0x1294 },
		{ "VAL237B@.MO8", 0x1c5acc, 0x0db3 },
		{ "VAL__1@.MO8",  0x1c687f, 0x15ba },	// t@Cs
		{ "VAL__2@.MO8",  0x1c7e39, 0x0e95 },	// t@Cs
		{ "VAL240@.MO8",  0x1c8cce, 0x1353 },
		{ "VAL241@.MO8",  0x1ca021, 0x0997 },
		{ "VAL242@.MO8",  0x1ca9b8, 0x0b62 },
		{ "VAL243@.MO8",  0x1cb51a, 0x0cb2 },
		{ "VAL244@.MO8",  0x1cc1cc, 0x1b61 },
		{ "",             0x000000, 0x0000 },	// End of Data
	};

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [file]\n",argv[0]);
		return 1;
	}

	strcpy(fname,argv[1]);
	fp=fopen(fname,"rb");	// ̓t@CI[v
	if (fp==NULL)
	{ 
		fprintf(stderr, "t@CJ܂.\n");
		return 1;
	}
	fread(buff, 1, sizeof(buff), fp);
	fclose(fp);

	// t@C
	if (!memcmp(&buff[0x23],id1,sizeof(id1)-1))
	{
		fprintf(stderr, "cutting from FLIXMIX.001 ...\n");
		for (f=0; md1[f].size; f++)
		{
			fxcut(fname, md1[f].filename, md1[f].loc, md1[f].size);
		}
	}
	else if (!memcmp(&buff[0x23],id2,sizeof(id2)-1))
	{
		fprintf(stderr, "cutting from FLIXMIX.002 ...\n");
		for (f=0; md2[f].size; f++)
		{
			fxcut(fname, md2[f].filename, md2[f].loc, md2[f].size);
		}
	}
	return 0;
}

// t@C̐؂o
bool fxcut(char *_sname, char *_dname, int _loc, int _size)
{
	FILE *fp1;
	FILE *fp2;
	int i,j,dt;
	fp1=fopen(_sname,"rb");	// ̓t@CI[v
	if (fp1==NULL)
	{
		fprintf(stderr, "t@Cǂݍ߂܂.\n");
		return false;
	}
	fp2=fopen(_dname,"wb");		// o̓t@CI[v
	if (fp2==NULL)
	{ 
		fprintf(stderr, "t@C߂܂.\n");
		return false;
	}
	// V[N
	fseek(fp1,_loc,SEEK_CUR);
	// ؂o
	for (j=0; j<_size; j++)
	{
		if (feof(fp1)) break;
		dt=fgetc(fp1);
		fputc(dt,fp2);
	}
	fclose(fp2);
	fclose(fp1);
	printf("%-13s  %08x  %04x\n",_dname, _loc, _size);
	return true;
}

