; Advanced Sound Bios "Kolin98" (Kolin 2nd)
; C[` (for NASM)

%include 'hoot.inc'

		ORG	0x0100
		USE16
		CPU	186

start:		cli
		mov	ax,0x257f	; hoothCoo^
		mov	dx,vect_7f
		int	0x21

		sti
mainloop:	hlt
		hlt
		hlt
		hlt
		jmp	short mainloop

; hootR[
; inp8(HOOTPORT) = 0  PC98DOS::Play
; inp8(HOOTPORT) = 2  PC98DOS::Stop
; _code = inp8(HOOTPORT+2)`inp8(HOOTPORT+5)

vect_7f:	pusha
		push	ds
		push	es
		mov	ax,cs
		mov	ds,ax
		mov	es,ax
		mov	dx,HOOTPORT
		in	al,dx
		cmp	al,HP_PLAY
		jz	short .play
		cmp	al,HP_STOP
		jz	short .fadeout
.ed:		pop	es
		pop	ds
		popa
		iret

.play:		mov	ah,0x01		; tI
		int	0xd2

		mov	ah,0x0e		; ȃf[^obt@AhX擾(DS:BX)
		int	0xd2
		mov	dx,bx
		xor	bx,bx		; W
		mov	cx,0xffff	; f[^TCY
		mov	ah,0x3f		; [DOS] read hundle
		int	0x21
		jc	.stop

		mov	ah,0x11		; ȃf[^̃Zbg
		int	0xd2

		mov	ah,0x0d		; po8t@C̎擾(DS:BX)
		int	0xd2
		mov	dx,bx
		mov	ax,0x3d00	; [DOS] open hundle
		int	0x21
		mov	cx,ax
		mov	bx,ax
		mov	ah,0x16		; po8t@C[h
		int	0xd2
		mov	bx,cx
		mov	ah,0x3e		; [DOS] close hundle
		int	0x21

		xor	ah,ah		; tJn
		int	0xd2
		jmp	short .ed

.stop:		mov	ah,0x02		; t~
		int	0xd2
		jmp	short .ed

.fadeout:	mov	ax,0x0402	; tF[hAEg
		int	0xd2
		jmp	short .ed

		ends

